sub init()
    print "INIT: AuthorizeScene"
    m.authlogin = ""
    m.authpassword = ""
    
    m.spinner = m.top.FindNode("spinner")
    m.spinner.poster.uri="pkg:/images/loader.png"
    
    m.KeepAliveTimer = m.top.FindNode("KeepAliveTimer")
    m.KeepAliveTimer.ObserveField("fire","keepAlive")
    
    m.screenSupport = m.top.findNode("labelBottomEmail")
    m.screenSupport.text = m.global.email
    
    m.loginScreen = m.top.findNode("loginScreen")
    m.top.setFocus(true)

    
    'getTimezones()
    'stbAutorize()
    checkRegistryAuthorize()
end sub

sub showLoginScreen()
    m.spinner.visible = false
    m.loginScreen.visible = true
    
    m.screenTitle = m.top.findNode("labelTitle")
    m.screenText = m.top.findNode("labelDesc")
    
    m.screenSupport = m.top.findNode("labelBottomEmail")
    m.screenSupport.text = m.global.email
    
    m.buttonGroup = m.top.findNode("buttonGroup")
    m.buttonGroup.buttons = [ getTr("Sign In"), getTr("7 days FREE trial") ]
    'buttonGroup.textFont = m.global.fonts.regular
    'buttonGroup.focusedTextFont = m.global.fonts.regular
    ShowSignInText()
    
    m.buttonGroup.observeField("buttonFocused", "OnButtonFocused")
    m.buttonGroup.observeField("buttonSelected", "OnButtonSelect")
    
    'm.top.setFocus(true) 
    m.buttonGroup.setFocus(true) 
    m.buttonGroup.focusButton = 0
end sub

sub LogOut()
    if m.top.logout
        DeleteToken()
        showLoginScreen()
        m.top.logout = false
    endif
end sub

sub ShowSignInText()
    m.screenTitle.text = getTr("Already With Us?")
    m.screenText.text  = getTr("Sign in and watch").Replace("%1", m.global.appName) 
end sub

sub ShowTrialText()
    m.screenTitle.text = getTr("Start Free TV Trial")
    m.screenText.text  = getTr("Watch the best")
end sub
'*********************************************************** 
sub OnButtonFocused()
    print "AUTH: OnButtonFocused=";m.buttonGroup.buttonFocused
    if m.buttonGroup.buttonFocused = 0
        ShowSignInText()
    else if m.buttonGroup.buttonFocused = 1
        ShowTrialText()
    end if
end sub

sub OnButtonSelect()
    print "AUTH: OnButtomSelect=";m.buttonGroup.buttonSelected
    if m.buttonGroup.buttonSelected = 0
        ShowLoginKeyBoard(m.authlogin)
    else if m.buttonGroup.buttonSelected = 1
        DemoAuth()
    end if
end sub
'*********************************************************** 
sub ShowLoginKeyBoard(logintext)
    print "AUTH: ShowLoginKeyBoard, login=";logintext
    m.authlogin = logintext

    m.keyboarddialog = createObject("roSGNode", "KeyboardDialog")
    m.keyboarddialog.title = getTr("Enter Your Login")
    m.keyboarddialog.text = logintext
    m.keyboarddialog.keyboard.textEditBox.cursorPosition = Len(logintext)
    m.keyboarddialog.buttons=[getTr("Next"),getTr("Cancel")]
    m.keyboarddialog.observeField("buttonSelected","OnLoginKeyPress")
    
    m.global.mainScene.dialog = m.keyboarddialog    
end sub

sub OnLoginKeyPress()
    print "AUTH: OnLoginKeyPress=";m.keyboarddialog.buttonSelected
    if m.keyboarddialog.buttonSelected = 0
        if Len(m.keyboarddialog.text) > 3
            m.authlogin = m.keyboarddialog.text
            m.keyboarddialog.close = true
            ShowPassKeyBoard()
        else
            ShowDialog("Incorrect Login!","Please, check your login!")
        end if
    else if m.keyboarddialog.buttonSelected = 1
        m.keyboarddialog.close = true
    end if
end sub
'*********************************************************** 
sub ShowPassKeyBoard()
    print "AUTH: ShowPassKeyBoard"
    m.keyboarddialog2 = createObject("roSGNode", "KeyboardDialog")
    m.keyboarddialog2.title = getTr("Enter Your Password")
    m.keyboarddialog2.text = ""
    m.keyboarddialog2.buttons=[getTr("Sign In"),getTr("Cancel")]
    m.keyboarddialog2.observeField("buttonSelected","OnPassKeyPress")
    
    m.global.mainScene.dialog = m.keyboarddialog2
end sub

sub OnPassKeyPress()
    print "AUTH: OnPassKeyPress=";m.keyboarddialog2.buttonSelected
    if m.keyboarddialog2.buttonSelected = 0
        if Len(m.keyboarddialog2.text) > 3
            m.authpassword = m.keyboarddialog2.text
            checkAuthData(m.authlogin,m.authpassword)
        else
            ShowDialog("Incorrect Password!","Please, check your password!")
        end if
    else if m.keyboarddialog2.buttonSelected = 1
        m.keyboarddialog2.close = true
    end if
end sub
'*********************************************************** 
sub checkRegistryAuthorize()
    print "...Start Registry Authorize"
    m.authData = GetAuthData()
    if m.authData <> invalid and m.authData.Count() > 1
        print "AUTH: Registry Authorize - user = " + m.authData[0]
        checkAuthData(m.authData[0], m.authData[1])
    else
        print "AUTH: No Registry Authorize data!"
        showLoginScreen()
    end if
end sub

function GetAuthData() As Object
     section = CreateObject("roRegistrySection", "Authentication")
     if section.Exists("UserRegistrationToken")
         token = section.Read("UserRegistrationToken")
         return token.Split("&")
     endif
     return invalid
end Function

function SaveAuthData(username As String, password As String) As Void
    if username.Len() < 1 or password.Len() < 1
        print "REGISTRY SAVE: Auth Data = invalid"
        return
    end if

    token = username + "&" + password
    'print "REGISTRY SAVE: TOKEN = "+token

    section = CreateObject("roRegistrySection", "Authentication")
    section.Write("UserRegistrationToken", token)
    section.Flush()
end Function

function DeleteToken() As Void
    section = CreateObject("roRegistrySection", "Authentication")
    if section.Exists("UserRegistrationToken")
        section.Delete("UserRegistrationToken")
        section.Flush()
    end if
end Function
'*********************************************************** 
sub stbAutorize()
    print "...Start STB Authorize"
    m.stbActive = true
    m.info = CreateObject("roDeviceInfo")
    mac = m.info.GetConnectionInfo().mac
    serial = m.info.GetChannelClientId()
    
    ShowLoadingDialog("Loading...")
    m.request = createObject("roSGNode","PostRequest")
    m.request.uri = m.global.apipath+m.global.apiname+"/core/ws/AuthStb" 
    m.request.params = "mac="+mac+"&serial="+serial
    m.request.observeField("content","OnAuthStbData")
    m.request.control = "RUN"
end sub

sub OnAuthStbData()
    HideLoadingDialog()
    print "OnAuthStbData: ";m.request.content
    
    json = ParseJSON(m.request.content)
    if(json = invalid)
        print "...Error STB Authorized!"
        showLoginScreen()
    else
        if(json.user <> invalid)
            print "...Success STB Authorized!"
            'showLoginScreen()
            loadHomePage(json)
        else
            if(json.id <> invalid)
                print "...Need to Activate STB"
                m.stbAuthId = json.id
                m.stbActive = json.active
                showLoginScreen()
            endif
        endif
    endif
end sub
'*********************************************************** 
sub DemoAuth()
    ShowLoadingDialog("Start Trial...")
    m.request = createObject("roSGNode","GetRequest")
    m.request.uri = m.global.apipath+m.global.apiname+"/core/ws/DemoUser"
    m.request.observeField("content","OnDemoData")
    m.request.control = "RUN"
end sub
 
sub OnDemoData()
    HideLoadingDialog()
    print "OnDemoData: ";m.request.content
    
    json = ParseJSON(m.request.content)
    if(json<>invalid and json.sessionId<>invalid)
        print "...OnDemoData Success! sessionId="+json.sessionId
        loadHomePage(json)
    else
        print "...OnDemoData json = Invalid! Error"
        ShowDialog("Not available","Sorry! Trial mode not available now! Try again later.")
    end if
end sub
'*********************************************************** 
sub checkAuthData(login, pass)
    ShowLoadingDialog("Sign In...")
    m.request = createObject("roSGNode","PostRequest")
    m.request.uri = m.global.apipath+m.global.apiname+"/core/ws/Auth" 
    m.request.params = "username="+login+"&password="+pass
    m.request.observeField("content","OnAuthData")
    m.request.control = "RUN"
end sub
 
sub OnAuthData()
    HideLoadingDialog()
    print "OnAuthData: ";m.request.content
    
    json = ParseJSON(m.request.content)
    if(json<>invalid and json.sessionId<>invalid)
        print "...OnAuthData Success! sessionId="+json.sessionId
        SaveAuthData(m.authlogin,m.authpassword)
        loadHomePage(json)
    else
        print "...OnAuthData json = Invalid! Error"
        if m.request.code = 403
            ShowDialog("Sign In error","Incorrect Login or Password!")
        else
            ShowDialog("Error","Connection Fail...")
        endif
        if not m.loginScreen.visible
            showLoginScreen()
        endif
    end if
end sub
'*********************************************************** 
sub loadHomePage(json)
        'm.daysToEnd = Int(json.packetInfo.daysBeforeExp/86400)
        'm.packetName = json.packetInfo.packetName
        if m.global.user = invalid
            m.global.addFields({
                user: json.user,
                account: json.account,
                packetInfo: json.packetInfo,
                sessionId: json.sessionId,
                language: getLanguageName(json.user.languageId)
            })
        else
            m.global.user = json.user
            m.global.account = json.account
            m.global.packetInfo = json.packetInfo
            m.global.sessionId = json.sessionId
            m.global.language = getLanguageName(json.user.languageId)
        end if
        
        print "USER timeShift: "+m.global.user.timeShift.tostr()
        print "USER timeZoneId: "+m.global.user.timeZoneId.tostr()
        print "USER LANGUAGE: "+m.global.language

        if(m.stbActive = false)
            ActivateStb()
        else
            getTimezones()
        end if
end sub

sub loadHomePageNext()
    m.top.visible = false
    if m.global.lastTime = invalid
        m.global.addFields({
            lastTime: 0,
        })
    end if
    keepAlive()
    m.KeepAliveTimer.control = "start"
end sub
'*********************************************************** 
sub ActivateStb()
    print "...Start Activate STB"
    ShowLoadingDialog("Activation...")
    m.request = createObject("roSGNode","GetRequest")
    m.request.uri = m.global.apipath+m.global.apiname+"/core/ws/AuthStb?id="+m.stbAuthId.tostr()+"&sessionId="+m.global.sessionId
    m.request.observeField("content","OnActivateStb")
    m.request.control = "RUN"
end sub

sub OnActivateStb()
    HideLoadingDialog()
    print "ActivateStb: ";m.request.content
    getTimezones()
end sub
'***********************************************************
sub keepAlive()
    m.request = createObject("roSGNode","GetRequest")
    m.request.uri = m.global.apipath+m.global.apiname+"/core/ws/KeepAlive?sessionId="+m.global.sessionId
    m.request.observeField("content","onKeepAlive")
    m.request.control = "RUN"
end sub
 
sub onKeepAlive()
    HideLoadingDialog()
    print "onKeepAlive: ";m.request.content    
    json = ParseJSON(m.request.content)
    if(json<>invalid and json.time<>invalid)
        m.global.lastTime = json.time
    end if
end sub
'***********************************************************
sub getTimezones()
    ShowLoadingDialog("Loading...")
    m.request = createObject("roSGNode","GetRequest")
    m.request.uri = m.global.apipath+m.global.apiname+"/core/ws/TimeZone"
    m.request.observeField("content","onTimezones")
    m.request.control = "RUN"
end sub
 
sub onTimezones()
    HideLoadingDialog()
    print "onTimezone: ";m.request.content
    
    json = ParseJSON(m.request.content)
    if(json<>invalid and json.items<>invalid)
        timeZones = json.items       
        if(m.global.hasField("timeZones"))
            m.global.timeZones = timeZones
        else
            m.global.addFields({timeZones: timeZones})
        end if
        
        if(m.global.timeZones.Count()>0)     
            timeZoneShift = getTimeZoneById(m.global.user.timeZoneId, m.global.timeZones)
            print "timeZoneShift = ";timeZoneShift 
            if(m.global.hasField("timeZoneShift"))
                m.global.timeZoneShift = timeZoneShift
            else
                m.global.addFields({timeZoneShift: timeZoneShift})
            end if
            print "onTimezone: timeZoneShift = "+timeZoneShift.tostr()
        end if 
        
    end if 
    
    loadHomePageNext()
end sub
'***********************************************************
sub setTimezone(timezoneID)
    print "##### ...setTimezone"
    m.request = createObject("roSGNode","PostRequest")
    m.request.uri = m.global.apipath+m.global.apiname+"/core/ws/User?sessionId="+m.global.sessionId
    m.request.params = "timezoneId="+timezoneID.tostr()'+"&timeshift=true"
    'm.request.params = "timeshift=true"
    m.request.observeField("content","OnSetTimezone")
    m.request.control = "RUN"
end sub

sub OnSetTimezone()
    print "##### OnSetTimezone: ";m.request.content
    json = ParseJSON(m.request.content)
    if(json = invalid)
        print "#####  ...Error Set Timezone!"
    else
        print "#####  Success Set Timezone!"
    endif
end sub