sub init()
    print "INIT: SettingsList"
    
    m.top.panelSize = "medium"
    m.top.focusable = true
    m.top.hasNextPanel = false
    m.top.leftOnly = false
    m.top.goBackCount = 1
    
    m.top.createNextPanelOnItemFocus = false
    m.top.selectButtonMovesPanelForward = false
    
    m.SettingsList = m.top.findNode("SettingsList")
    m.top.list = m.SettingsList 

    m.SettingsList.font = m.global.fonts.regular24
    m.SettingsList.focusedFont = m.global.fonts.regular24
    
    UpdateSettingsList()
    
    if m.global.servers = invalid
        GetServers()
    end if
end sub
'******************************************************
sub UpdateSettingsList()
    if m.top.settingsID = 0
        ShowAccountSettings()
    else if m.top.settingsID = 1
        ShowLanguageSettings()
    else if m.top.settingsID = 2
        ShowTimeshitSettings()
    else if m.top.settingsID = 3
        ShowServerSettings()
    else if m.top.settingsID = 4
        ShowAboutSettings()
    end if
end sub

sub AddInfoNode(nodeName, nodeValue)
    if m.content = invalid
        m.content = createObject("RoSGNode","ContentNode")
    end if

    node = m.content.createChild("ExtendedNode")
    node.title = nodeName+": "+nodeValue
    'node.nodeText = nodeValue
    node.nodeID = m.content.getChildCount() - 1
    node.HDLISTITEMICONURL = "pkg:/images/empty.png"
    node.HDLISTITEMICONSELECTEDURL = "pkg:/images/empty.png"
end sub

sub AddRadioButtonNode(nodeID, nodeName, isSelected)
    if m.content = invalid
        m.content = createObject("RoSGNode","ContentNode")
    end if

    node = m.content.createChild("ExtendedNode")
    node.title = nodeName
    node.nodeID = nodeID
    if isSelected
        node.HDLISTITEMICONURL = "pkg:/images/icon_checkmark.png"
        node.HDLISTITEMICONSELECTEDURL = "pkg:/images/icon_checkmark.png"
    else
        node.HDLISTITEMICONURL = "pkg:/images/empty.png"
        node.HDLISTITEMICONSELECTEDURL = "pkg:/images/empty.png"
    end if
end sub
'******************************************************
sub ShowAccountSettings()
    print "Show Account Settings..."
    m.content = createObject("RoSGNode","ContentNode")
    AddInfoNode(getTr("Username"), m.global.user.username)
    AddInfoNode(getTr("Email"), m.global.user.email)
    AddInfoNode(getTr("Timezone"), getTimeZoneNameById(m.global.user.timezoneId, m.global.timeZones))
    AddInfoNode(getTr("Balance"), getCurrencyName(m.global.account.currencyId)+" "+m.global.account.balance.tostr())
    AddInfoNode(getTr("Packet"), m.global.packetInfo.packetName)

    node = m.content.createChild("ExtendedNode")
    node.title = getTr("Log Out")
    node.nodeID = -1
    node.HDLISTITEMICONURL = "pkg:/images/icon_logout.png"
    node.HDLISTITEMICONSELECTEDURL = "pkg:/images/icon_logout.png"

    m.top.list.content = m.content
end sub
'******************************************************
sub ShowLanguageSettings()
    print "Show Language Settings..."
    m.content = createObject("RoSGNode","ContentNode")
    AddRadioButtonNode(2, "English", m.global.user.languageId=2)
    AddRadioButtonNode(3, "Русский", m.global.user.languageId=3)
    AddRadioButtonNode(1, "Українська", m.global.user.languageId=1)
    m.top.list.content = m.content
end sub
'******************************************************
sub ShowTimeshitSettings()
    print "Show Timeshit Settings... timeShift =";m.global.user.timeShift
    m.content = createObject("RoSGNode","ContentNode")
    AddRadioButtonNode(1, getTr("Enable"), m.global.user.timeShift)
    AddRadioButtonNode(0, getTr("Disable"), not m.global.user.timeShift)
    m.top.list.content = m.content
end sub
'******************************************************
sub ShowServerSettings()
    print "Show Server Settings..."
    m.content = createObject("RoSGNode","ContentNode")
    for each server in m.global.servers.items
        AddRadioButtonNode(server.id, server.name, (server.id = m.global.servers.attachedServerId))
    end for
    m.top.list.content = m.content
end sub
'******************************************************
sub ShowAboutSettings()
    print "Show About Settings..."
    m.content = createObject("RoSGNode","ContentNode")
    AddInfoNode(getTr("Version"), m.global.appVersion)
    AddInfoNode(getTr("Support"), m.global.email)
    m.top.list.content = m.content
end sub
'******************************************************
sub SelectSettings(node)
    if m.top.settingsID = 0
        if node.nodeID = -1
            ShowLoguotDialog()
        end if
    else if m.top.settingsID = 1
        ' Select Language
        ChangeLanguage(node.nodeID)
    else if m.top.settingsID = 2
        ' Select TimeShift
        ChangeTimeshift(node.nodeID)
    else if m.top.settingsID = 3
        ' Select Server
        ChangeServer(node.nodeID)
    else if m.top.settingsID = 4
        ' Select About
    end if
end sub
'******************************************************
sub ChangeLanguage(id)
    if m.global.user.languageId <> id
        print "...Change Language"
        m.newSetting = id
        ShowLoadingDialog("Loading...")
        m.request = createObject("roSGNode","PostRequest")
        m.request.uri = m.global.apipath+m.global.apiname+"/core/ws/User?sessionId="+m.global.sessionId
        m.request.params = "languageId="+id.tostr()
        m.request.observeField("content","OnChangeLanguage")
        m.request.control = "RUN"
    end if
end sub

sub OnChangeLanguage()
    HideLoadingDialog()
    print "...OnChangeLanguage: ";m.request.content
    json = ParseJSON(m.request.content)
    if(json = invalid)
        print "...Error Change Language!"
        ShowDialog(getTr("Error"), getTr("Can't update settings"))
    else
        print "OnChangeLanguage: Success Set timeShift!"
        m.user = m.global.user
        m.user.languageId = m.newSetting
        m.global.user = m.user
        m.global.language = getLanguageName(m.global.user.languageId)
        m.global.mainScene.GenreListPanel.languageChange = true
        ShowLanguageSettings()
    endif
end sub
'******************************************************
sub ChangeTimeshift(id)
    if m.global.user.timeShift <> (id=1)
        print "...Change Timeshift"
        m.newSetting = id
        ShowLoadingDialog("Loading...")
        m.request = createObject("roSGNode","PostRequest")
        m.request.uri = m.global.apipath+m.global.apiname+"/core/ws/User?sessionId="+m.global.sessionId
        m.request.params = "timeshift="+(id=1).tostr()
        m.request.observeField("content","OnSetTimeshift")
        m.request.control = "RUN"
    end if
end sub

sub OnSetTimeshift()
    HideLoadingDialog()
    print "...OnSetTimeshift: ";m.request.content
    json = ParseJSON(m.request.content)
    if(json = invalid)
        print "...Error Set Timeshift!"
        ShowDialog(getTr("Error"), getTr("Can't update settings"))
    else
        print "OnSetTimeshift: Success Set timeShift!"
        print "OnSetTimeshift: 1 timeShift = ";m.global.user.timeShift
        m.user = m.global.user
        m.user.timeShift = (m.newSetting = 1)
        m.global.user = m.user
        print "OnSetTimeshift: 2 timeShift = ";m.global.user.timeShift
        ShowTimeshitSettings()
    endif
end sub
'******************************************************
sub ChangeServer(id)
    if m.global.servers.attachedServerId <> id
        print "...Change Server"
        ShowLoadingDialog("Loading...")
        m.request = createObject("roSGNode","PostRequest")
        m.request.uri = m.global.apipath+m.global.apiname+"/core/user/ws/HasServerName?sessionId="+m.global.sessionId
        m.request.params = "id="+id.tostr()
        m.request.observeField("content","OnSetServer")
        m.request.control = "RUN"
        m.newSetting = id
    end if
end sub

sub OnSetServer()
    HideLoadingDialog()
    print "...OnSetServer: ";m.request.content
    json = ParseJSON(m.request.content)
    if(json = invalid)
        print "...Error Set Server!"
        'ShowDialog("Error","Can't update settings")
    else
        print "OnSetTimeshift: Success Set Server!"
    endif
    m.servers = m.global.servers
    m.servers.attachedServerId = m.newSetting
    m.global.servers = m.servers
    ShowServerSettings()
end sub

sub GetServers()
    ShowLoadingDialog("Loading...")
    m.request = createObject("roSGNode","GetRequest")
    m.request.uri = m.global.apipath+m.global.apiname+"/core/user/ws/ServerNameForVY?sessionId="+m.global.sessionId
    m.request.observeField("content","OnGetServers")
    m.request.control = "RUN"
end sub

sub OnGetServers()
    HideLoadingDialog()
    print "OnGetServers: ";m.request.content
    json = ParseJSON(m.request.content)
    if(json<>invalid and json.items<>invalid)     
        if(m.global.hasField("servers"))
            m.global.servers = json
        else
            m.global.addFields({servers: json})
        end if
    end if 
end sub
'******************************************************
sub ShowLoguotDialog()
    m.dialog = createObject("roSGNode","Dialog")
    m.dialog.title = getTr("Do you really want to log out?")
    m.dialog.optionsDialog = true
    m.dialog.titleFont = m.global.fonts.regular20
    m.dialog.buttonGroup.textFont = m.global.fonts.regular18
    m.dialog.buttonGroup.focusedTextFont = m.global.fonts.regular18
    m.dialog.buttonGroup.focusBitmapUri = "pkg:/images/select.9.png"
    m.dialog.buttonGroup.focusFootprintBitmapUri = "pkg:/images/selected.9.png"
    
    newarray = CreateObject("roArray", 1, true)
    newarray.Push(getTr("Cancel"))
    newarray.Push(getTr("Log Out"))
    m.dialog.buttons = newarray
    m.dialog.focusButton = 0
    m.dialog.observeField("buttonSelected","OnLogout")
    
    m.global.mainScene.dialog = m.dialog
end sub

sub OnLogout()
    if m.dialog <> invalid
        if m.dialog.buttonSelected = 1
            print "...Logout"
            m.global.mainScene.logout = true
        end if
        m.dialog.close = true
    end if 
end sub
'******************************************************
Function OnKeyEvent(key, press) as Boolean    
    result = false
    if press then
        print "SettingsList: OnkeyEvent = ";key
        if key = "options"
            '
        else if key = "OK"
            SelectSettings(m.top.list.content.getChild(m.top.list.itemFocused))
        else if key = "back"
            
        end if
    end if
    return result
End Function