sub init()
    m.video = m.top.findNode("VideoPlayer")
    m.video.notificationInterval = 1
    m.video.ObserveField("position","OnPositionGhange")
    m.video.ObserveField("state","OnStateGhange")
     
    m.OSDPanel = m.top.findNode("OSDPanel")
    m.OSDchannelName = m.top.findNode("OSDchannelName")
    m.OSDchannelIcon = m.top.findNode("OSDchannelIcon")
    m.OSDchannelName.font = m.global.fonts.regular24
    
    m.OSDprogress = m.top.findNode("OSDprogress")
    m.OSDBack = m.top.findNode("OSDBack")
    m.OSDprogramsBack = m.top.findNode("OSDprogramsBack")
    m.OSDprogramName = m.top.findNode("OSDprogramName")
    m.OSDprogramName.font = m.global.fonts.regular20
    m.OSDStatus = m.top.findNode("OSDStatus")
    
    m.OSDprogramHelp = m.top.findNode("OSDprogramHelp")
    m.OSDprogramHelp.font = m.global.fonts.regular20
    m.OSDprogramHelp.text = getTr("Press OK")
    
    m.OSDseek = m.top.findNode("OSDseek")
    m.OSDseekPause = m.top.findNode("OSDseekPause")
    m.OSDseekTime = m.top.findNode("OSDseekTime")
    m.OSDseekTime.font = m.global.fonts.bold32
    
    m.OSDseekTimer = m.top.findNode("OSDseekTimer")
    m.OSDseekTimer.ObserveField("fire","OnSeek")

    m.OSDseekTimer2 = m.top.findNode("OSDseekTimer2")
    m.OSDseekTimer2.ObserveField("fire","OnStopSeek")
    
    m.OSDTimer = m.top.findNode("OSDTimer")    
    m.OSDTimer.ObserveField("fire","HideOSD")
    
    m.progressDefault = 18
    m.top.isPlaying = false
    m.top.isPaused = false
    m.top.isSeeked = false
    m.top.isError = false
    
    m.seekTime = 0
    m.seekDelta = 0
    
     for i=0 to m.video.getChildCount()-1
        if m.video.getChild(i).hasField("font")
            m.video.getChild(i).font = m.global.fonts.regular20
        end if
        for j=0 to m.video.getChild(i).getChildCount()-1
            if m.video.getChild(i).getChild(j).hasField("font")
                m.video.getChild(i).getChild(j).font = m.global.fonts.regular20
            end if
        end for
    end for
end sub
'******************************************************
sub OnTopChanged()
    m.OSDprogramsBack.visible = (not m.top.onTop and m.top.isPlaying)
    m.OSDprogramHelp.visible = m.top.onTop and m.OSDPanel.visible
    
    if m.top.onTop and m.top.isPaused
        ShowPause()
    end if
    
    if not m.top.onTop and m.top.isPaused
        HidePause()
    end if
end sub
'******************************************************
sub GetUrl()
    if m.top.playingChannel.channelLocked
        CheckPin()
    else
        GetUrlNext("")    
    end if
end sub

sub CheckPin()
    if m.top.isPlaying
        'm.video.control = "stop"
    end if
    ShowPinDialog(m.top.playingChannel.channelName, "OnCheckPin")
end sub

sub OnCheckPin()
    pincode = GetEnteredPin()
    HidePinDialog()
    if pincode = ""
        print "CANCEL PinDialog..."
        if m.top.onTop
            ShowOSD()
        end if
        return
    end if
    GetUrlNext("&pin="+pincode)
end sub

sub GetUrlNext(pin)
    timestamp = ""
    if not m.top.isLive
        timestamp = "&timestamp="+m.top.videoStartTimestamp.tostr()
    end if
    
    ShowLoadingDialog(getTr("Loading..."))
    m.request = createObject("roSGNode","GetRequest")
    m.request.uri = m.global.apipath+m.global.apiname+"/tv/ws/TransmissionUrl?poolType=TV&channelId="+m.top.playingChannel.channelID.tostr()+pin+timestamp+"&sessionId="+m.global.sessionId
    m.request.observeField("content","OnGetUrl")
    m.request.control = "RUN"
end sub

sub OnGetUrl()
    print "OnGetUrl: ";m.request.content
    json = ParseJSON(m.request.content)
    if(json<>invalid and json.url<>invalid)
        HideLoadingDialog()
        m.top.url = json.url
        if m.top.isLive
            playUrlShifted = json.url
            shift = GetTimeShiftSeconds(m.top.playingChannel.channelNum)
            if(shift>0) 
                if findSymbol(json.url,"?")
                    playUrlShifted = json.url + "&shift="+shift.tostr()
                else
                    playUrlShifted = json.url + "?shift="+shift.tostr()
                end if
                print "PLAYshift=" + Str(shift/3600) 
            end if
            PlayStream(playUrlShifted)
        else
            endTimestamp = m.top.videoStartTimestamp + 5 * 3600
            if endTimestamp > m.global.lastTime
                endTimestamp = m.global.lastTime
            end if
            
            if findSymbol(json.url,"?")
                archiveUrl = json.url + "&min="+m.top.videoStartTimestamp.tostr()+"&max="+endTimestamp.tostr()
            else
                archiveUrl = json.url + "?min="+m.top.videoStartTimestamp.tostr()+"&max="+endTimestamp.tostr()
            end if
            PlayStream(archiveUrl)
        end if
    else
        HideLoadingDialog()
        if m.top.playingChannel.channelLocked
            CheckPin()
        else
            ShowDialog(getTr("Error"), getTr("Can't get channel stream url..."))
        endif
        if m.top.onTop
            ShowOSD()
        end if
    end if
end sub

sub PlayStream(url)
    print "VideoPlayer: PlayStream: ";url
    videoContent = createObject("RoSGNode", "ContentNode")
    videoContent.url = url
    videoContent.title = m.top.playingChannel.channelName
    videoContent.streamformat = "hls"

    m.top.videoCurTimestamp = m.top.videoStartTimestamp+1
    SetLoadingOSD()
    
    ShowOSD()
    
    PlayVideo(videoContent)
end sub
'******************************************************
sub PlayVideo(videoContent)
    m.video.content = videoContent
    m.video.control = "play"
    m.top.isPlaying = true
    m.top.isSeeked = false
    m.top.isPaused = false
    m.top.isError = false
    m.video.visible = true
    m.top.onTop = true
    
    HidePause()
end sub

sub StopVideo()
    print "VideoPlayer: StopVideo! onTop = ";m.top.onTop
    if m.top.isSeeked
        m.OSDseekTimer.control = "stop"
        m.OSDseekTimer2.control = "stop"
        OnStopSeek()
    end if
    if m.OSDPanel.visible
        HideOSD()
    end if
    if m.top.isPaused
        HidePause()
    end if
    
    m.video.control = "stop"
    'm.top.playingGenre = invalid
    'm.top.playingChannel = invalid
    'm.top.playingPrograms = invalid
    m.top.playingDayNum = 0
    m.video.visible = false
    m.top.onTop = false
end sub

sub PauseVideo()
    m.video.control = "pause"
    if not m.top.isSeeked
        ShowPause()
    end if
end sub

sub ResumeVideo()
    m.video.control = "resume"
    HidePause()
end sub

sub StartSeek(sec)
    print "VideoPlayer: StartSeek = ";sec
    if not m.top.isCinema
        if not m.top.playingChannel.channelRecord
            ShowOSD()
            return
        end if

        currTimestamp = CreateObject("roDateTime").AsSeconds()
        seekTimestamp = m.top.videoCurTimestamp + m.seekTime + sec
        print "!!!!!!! currTimestamp = ";currTimestamp
        print "!!!!!!! seekTimestamp = ";seekTimestamp
    
        if seekTimestamp >= currTimestamp
            sec = currTimestamp - (m.top.videoCurTimestamp + m.seekTime)
            print "!!!!!!! sec = ";sec
            if sec < 5
                sec = 0
            endif
            if not m.top.isLive 
                print "!!!!!!! m.top.isLive = Enable"
                m.top.isLive = true
            end if
        else
            if m.top.isLive 
                print "!!!!!!! m.top.isLive = DISABLE"
                m.top.isLive = false
            end if
        endif
    endif   

    m.OSDseekTimer.control = "stop"
    m.OSDseekTimer2.control = "stop"
    
    if not m.top.isSeeked
        m.seekTime = 0
        m.top.isSeeked = true
        m.OSDseek.visible = true
        m.OSDseekPause.uri = ""
        m.OSDseekTime.text = "+"+convertSecondsToTime(m.seekTime)
        PauseVideo()
        ShowOSD()
    end if
    
    m.OSDseekTimer.control = "start"
    m.seekDelta = sec
    
    OnSeek()
end sub

sub OnSeek()
    m.seekTime += m.seekDelta
    print "VideoPlayer: OnSeek = ";m.seekTime
    GetOSD(m.top.videoCurTimestamp + m.seekTime)
    
    sigh = "+"
    if m.seekTime < 0
        sigh = "-"
    end if
    m.OSDseekTime.text = sigh + convertSecondsToTime(m.seekTime)
end sub

sub StopSeekDelay()
    print "VideoPlayer: StopSeekDelay... seekTime = ";m.seekTime
    m.OSDseekTimer.control = "stop"
    m.OSDseekTimer2.control = "stop"
    m.OSDseekTimer2.control = "start"    
end sub

sub OnStopSeek()
    print "VideoPlayer: OnStopSeek - seekTime = ";m.seekTime
    if m.top.isSeeked
        m.top.isSeeked = false
        m.OSDseek.visible = false
        ResumeVideo()
        
        if m.top.isCinema
            timestamp = m.video.position + m.seekTime
            if timestamp < 0 
                timestamp = 0
            end if
            
            if timestamp >= m.video.duration
                timestamp = m.video.duration-1
            end if
            
            m.video.seek = timestamp
        else
            m.top.videoStartTimestamp = m.top.videoCurTimestamp + m.seekTime
        end if
        
        ShowOSD()  

        m.seekTime = 0
        m.seekDelta = 0
    end if
end sub

sub OnStateGhange()
    print "VideoPlayer: OnStateGhange: ";m.video.state
    if m.video.state = "playing"
        m.top.isPlaying = true
        m.top.isPaused = false
    else if m.video.state = "stopped"
        m.top.isPlaying = false
        m.top.isPaused = false
    else if m.video.state = "paused"
        m.top.isPaused = true
    else if m.video.state = "finished"
        if m.top.isError
            m.top.isError = false
        else
            StopVideo()
        end if 
    else if m.video.state = "error"
        print "VideoPlayer: errorCode = ";m.video.errorCode
        print "VideoPlayer: errorStr = ";m.video.errorStr
        print "VideoPlayer: errorMsg = ";m.video.errorMsg
        m.top.isError = true
        ShowDialog(getTr("Error"), getTr("Incorrect channel stream URL...")+" "+m.video.errorMsg)
    end if
end sub

sub OnPositionGhange()
    'print "VideoPlayer: OnPositionGhange = ";m.video.position
    if m.top.isCinema
        m.top.videoCurTimestamp = Int(m.video.position)
        GetOSD(m.top.videoCurTimestamp)
    else
        m.top.videoCurTimestamp = m.top.videoStartTimestamp + Int(m.video.position)
    end if 
end sub
'******************************************************
sub ShowOSD()
    print "ShowOSD..."
    m.OSDPanel.visible = true
    if m.top.isSeeked
        m.OSDTimer.control = "stop"
    else
        m.OSDTimer.control = "start"
        GetOSD(m.top.videoCurTimestamp)
    end if
end sub

sub HideOSD()
    print "HideOSD..."
    if m.top.onTop = false
        ShowOSD()
    else
        m.OSDPanel.visible = false
        m.OSDTimer.control = "stop"
    end if
end sub

sub ShowPause()
    print "ShowPause..."
    m.OSDseek.visible = true
    m.OSDseekPause.uri = "pkg:/images/pause.png"
    m.OSDseekTime.text = ""
end sub

sub HidePause()
    print "HidePause..."
    m.OSDseek.visible = false
    m.OSDseekPause.uri = ""
    m.OSDseekTime.text = ""
end sub
'******************************************************
sub SetOSD(progress, time, title)
    print "SetOSD: "+time+" - "+title
    m.OSDchannelName.text = m.top.playingChannel.channelName
    m.OSDchannelIcon.uri = m.top.playingChannel.channelIconUri
    m.OSDprogress.width = m.progressDefault + m.OSDBack.width * progress 
    'm.OSDprogramName.text = time + " - " + title
    if m.top.isLive
        m.OSDprogramName.text = time + " - " + title
        m.OSDStatus.uri = "pkg:/images/archive_live.png"
    else
        m.OSDprogramName.text = time + " - " + title + " (" + m.global.archiveDateString+")"
        m.OSDStatus.uri = "pkg:/images/archive_yes.png"
    end if
    
end sub

sub SetDefaultOSD()
    m.OSDchannelName.text = m.top.playingChannel.channelName
    m.OSDchannelIcon.uri = m.top.playingChannel.channelIconUri
    m.OSDprogress.width = m.progressDefault
    m.OSDprogramName.text = " "    
end sub

sub SetLoadingOSD()
    m.OSDchannelName.text = m.top.playingChannel.channelName
    m.OSDchannelIcon.uri = m.top.playingChannel.channelIconUri
    m.OSDprogress.width = m.progressDefault
    m.OSDprogramName.text = getTr("Loading...")
end sub
'******************************************************
sub GetOSD(timestamp)
    print "GET OSD: time = "+timestamp.tostr()
    if(m.top.playingPrograms <> invalid and m.top.playingPrograms.getChildCount() > 0)
        if m.top.isCinema
            ' CINEMA OSD
            duration = 1
            if m.video.duration > 0
                duration = m.video.duration
            end if
            
            if timestamp < 0 
                timestamp = 0
            end if
            
            if timestamp >= duration
                timestamp = duration-1
            end if

            progress = timestamp/duration
            time = convertSecondsToTime(timestamp)+"/"+convertSecondsToTime(duration)
            title = GetCinemaTitle(m.global.channels[m.top.playingChannel.channelNum].description)
            SetOSD(progress, time, title)
        else
            ' ARCHIVE or LIVE OSD
            index = findProgramNodeByTimestamp(timestamp, m.top.playingPrograms)
            print "GET OSD: index = "+index.tostr()
            if(index >= 0)
                program = m.top.playingPrograms.getChild(index)
                progress = (timestamp - program.programTimestamp) / (program.programEndTimestamp - program.programTimestamp)
                
                curTime = CreateObject("roDateTime")
                curTime.FromSeconds(timestamp)
                curTime.ToLocalTime() 

                endTime = CreateObject("roDateTime")
                endTime.FromSeconds(program.programEndTimestamp)
                endTime.ToLocalTime() 
                SetOSD(progress, convertDateToTime(curTime)+"/"+convertDateToTime(endTime), program.programTitle)
                'SetOSD(progress,  program.programTime, program.programTitle)
            else
                SetDefaultOSD()
            end if
        end if
        
    else
        SetLoadingOSD()
    end if    
    
end sub

sub GetOSDweb()
    m.request = createObject("roSGNode","GetRequest")
    if m.top.isLive
        m.request.uri = m.global.apipath+m.global.apiname+"/tv/ws/ChannelOsd?channelId="+m.top.playingChannel.channelID.tostr()+"&next=1&sessionId="+m.global.sessionId
    else
        m.request.uri = m.global.apipath+m.global.apiname+"/tv/ws/ChannelOsd?channelId="+m.top.playingChannel.channelID.tostr()+"&next=1&timestamp="+(m.top.videoCurTimestamp).tostr()+"&sessionId="+m.global.sessionId
    end if
    m.request.observeField("content","OnGetOSD")
    m.request.control = "RUN"
end sub

sub OnGetOSD()
    print "OnGetOSD: ";m.request.content
    json = ParseJSON(m.request.content)
    if(json<>invalid and json.title<>invalid)
        SetOSD( (json.passed/(json.endTimestamp-json.startTimestamp)), json.start, json.title )
    else
        SetDefaultOSD()
    end if
end sub

sub OnProgramsUpdate()
    print "VideoPlayer: OnProgramsUpdate..."
    GetOSD(m.top.videoCurTimestamp)
end sub
'******************************************************
sub NextChannel()
    m.global.mainScene.TVchannel++
end sub

sub PreChannel()
    m.global.mainScene.TVchannel--
end sub
'******************************************************
Function OnKeyEvent(key, press) as Boolean    
    result = false
    if press then
        print "VideoPlayer: OnkeyPress = ";key
        if key = "OK"  
            'if m.OSDPanel.visible                
            '    HideOSD()
            'else
            '    ShowOSD()                
            'end if
            ShowOSD()
            m.top.onTop = false
            result = true
        else if key = "options"
            'ShowOSD()
            'm.top.onTop = false
            'result = true
        else if key = "back"
            StopVideo()
            result = true
        else if key = "up"
            NextChannel()
            result = true
        else if key = "down"
            PreChannel()
            result = true
        else if key = "play"
            if m.video.state = "paused"
                ResumeVideo()
            else if m.video.state = "playing"
                PauseVideo()
            end if
            result = true
        else if key = "fastforward"
            StartSeek(60)
        else if key = "rewind"
            StartSeek(-60)
        end if
    else
        print "VideoPlayer: OnkeyRelease = ";key
        if key = "fastforward"
            StopSeekDelay()
        else if key = "rewind"
            StopSeekDelay()
        end if
    end if
    return result
End Function