sub init()
    m.video = m.top.findNode("MoviePlayer")
    m.video.notificationInterval = 1
    m.video.ObserveField("position","OnPositionGhange")
    m.video.ObserveField("state","OnStateGhange")
     
    m.OSDPanel = m.top.findNode("OSDPanel")
    m.OSDchannelName = m.top.findNode("OSDchannelName")
    m.OSDchannelIcon = m.top.findNode("OSDchannelIcon")
    m.OSDchannelName.font = m.global.fonts.regular24
    
    m.OSDprogress = m.top.findNode("OSDprogress")
    m.OSDBack = m.top.findNode("OSDBack")
    m.OSDprogramsBack = m.top.findNode("OSDprogramsBack")
    m.OSDprogramName = m.top.findNode("OSDprogramName")
    m.OSDprogramName.font = m.global.fonts.regular20
    m.OSDStatus = m.top.findNode("OSDStatus")
    
    m.OSDseek = m.top.findNode("OSDseek")
    m.OSDseekPause = m.top.findNode("OSDseekPause")
    m.OSDseekTime = m.top.findNode("OSDseekTime")
    m.OSDseekTime.font = m.global.fonts.bold32
    
    m.OSDseekTimer = m.top.findNode("OSDseekTimer")
    m.OSDseekTimer.ObserveField("fire","OnSeek")

    m.OSDseekTimer2 = m.top.findNode("OSDseekTimer2")
    m.OSDseekTimer2.ObserveField("fire","OnStopSeek")
    
    m.OSDTimer = m.top.findNode("OSDTimer")    
    m.OSDTimer.ObserveField("fire","HideOSD")
    
    m.top.movieID = -1
    m.progressDefault = 18
    m.top.isPlaying = false
    m.top.isPaused = false
    m.top.isSeeked = false
    m.top.isError = false
    
    m.seekTime = 0
    m.seekDelta = 0
    
     for i=0 to m.video.getChildCount()-1
        if m.video.getChild(i).hasField("font")
            m.video.getChild(i).font = m.global.fonts.regular20
        end if
        for j=0 to m.video.getChild(i).getChildCount()-1
            if m.video.getChild(i).getChild(j).hasField("font")
                m.video.getChild(i).getChild(j).font = m.global.fonts.regular20
            end if
        end for
    end for
end sub
'******************************************************
sub OnTopChanged()
    'm.OSDprogramsBack.visible = (not m.top.onTop and m.top.isPlaying)
    'm.OSDprogramHelp.visible = m.top.onTop and m.OSDPanel.visible
    
    if m.top.onTop and m.top.isPaused
        ShowPause()
    end if
    
    if not m.top.onTop and m.top.isPaused
        HidePause()
    end if
end sub
'******************************************************
sub GetUrl()
    if m.top.movieID < 0
        print "Get Movie URL: Incorrect movieID = ";m.top.movieID
        return
    end if

    print "...Get Movie URL"
    ShowLoadingDialog(getTr("Loading..."))
    if type(m.global.movieCategoryID) = "String"
        categoryId = m.global.movieCategoryID
    else
        categoryId = m.global.movieCategoryID.tostr()
    end if

    m.request = createObject("roSGNode","GetRequest")
    if m.top.movieSeriesID = 0
        m.request.uri = m.global.apipath+m.global.apiname+m.global.vodpath+"/vod/ws/VideoStream?categoryId="+categoryId+"&videoId="+m.top.movieID.ToStr()+"&sessionId="+m.global.sessionId
    else
        m.request.uri = m.global.apipath+m.global.apiname+m.global.vodpath+"/vod/ws/VideoStream?categoryId="+categoryId+"&videoId="+m.top.movieID.ToStr()+"&seriesId="+m.top.movieSeriesID.tostr()+"&sessionId="+m.global.sessionId
    end if
    m.request.observeField("content","OnGetUrl")
    m.request.control = "RUN"
end sub

sub OnGetUrl()
    print "OnGetMovieUrl: ";m.request.content
    json = ParseJSON(m.request.content)
    HideLoadingDialog()
    if(json<>invalid and json.src<>invalid)
        m.top.url = json.src
        
        PlayStream(m.top.url)
 
    else
        print "...GetMovieUrl Error!"
        'TODO: add translation
        ShowDialog(getTr("Error"), getTr("Can't get stream url..."))
    end if
end sub

sub PlayStream(url)
    print "MoviePlayer: PlayStream: ";url
    videoContent = createObject("RoSGNode", "ContentNode")
    videoContent.url = url
    videoContent.title = m.top.movieTitle
    videoContent.streamformat = "hls"

    m.top.currentPosition = 0

    ShowOSD()
    
    PlayVideo(videoContent)
end sub
'******************************************************
sub PlayVideo(videoContent)
    m.video.content = videoContent
    m.video.control = "play"
    m.top.isPlaying = true
    m.top.isSeeked = false
    m.top.isPaused = false
    m.top.isError = false
    m.top.onTop = true
    m.video.visible = true
    
    HidePause()
end sub

sub StopVideo()
    print "MoviePlayer: StopVideo!"
    if m.top.isSeeked
        m.OSDseekTimer.control = "stop"
        m.OSDseekTimer2.control = "stop"
        OnStopSeek()
    end if
    if m.OSDPanel.visible
        HideOSD()
    end if
    if m.top.isPaused
        HidePause()
    end if
    
    m.video.control = "stop"
    m.video.visible = false
    m.top.onTop = false
    m.top.movieID = -1
end sub

sub PauseVideo()
    m.video.control = "pause"
    if not m.top.isSeeked
        ShowPause()
    end if
end sub

sub ResumeVideo()
    m.video.control = "resume"
    HidePause()
end sub

sub StartSeek(sec)
    print "MoviePlayer: StartSeek = ";sec

    m.OSDseekTimer.control = "stop"
    m.OSDseekTimer2.control = "stop"
    
    if not m.top.isSeeked
        m.seekTime = 0
        m.top.isSeeked = true
        m.OSDseek.visible = true
        m.OSDseekPause.uri = ""
        m.OSDseekTime.text = "+"+convertSecondsToTime(m.seekTime)
        PauseVideo()
        ShowOSD()
    end if
    
    m.OSDseekTimer.control = "start"
    m.seekDelta = sec
    
    OnSeek()
end sub

sub OnSeek()
    m.seekTime += m.seekDelta
    print "MoviePlayer: OnSeek = ";m.seekTime
    UpdateOSD(m.top.currentPosition + m.seekTime)
    
    sigh = "+"
    if m.seekTime < 0
        sigh = "-"
    end if
    m.OSDseekTime.text = sigh + convertSecondsToTime(m.seekTime)
end sub

sub StopSeekDelay()
    print "MoviePlayer: StopSeekDelay... seekTime = ";m.seekTime
    m.OSDseekTimer.control = "stop"
    m.OSDseekTimer2.control = "stop"
    m.OSDseekTimer2.control = "start"    
end sub

sub OnStopSeek()
    print "MoviePlayer: OnStopSeek - seekTime = ";m.seekTime
    if m.top.isSeeked
        m.top.isSeeked = false
        m.OSDseek.visible = false
        ResumeVideo()
        
        newPosition = m.video.position + m.seekTime
        if newPosition < 0 
            newPosition = 0
        end if
        
        if newPosition >= m.video.duration
            newPosition = m.video.duration-1
        end if
        
        m.video.seek = newPosition
        
        ShowOSD()  

        m.seekTime = 0
        m.seekDelta = 0
    end if
end sub

sub OnStateGhange()
    print "MoviePlayer: OnStateGhange: ";m.video.state
    if m.video.state = "playing"
        m.top.isPlaying = true
        m.top.isPaused = false
    else if m.video.state = "stopped"
        m.top.isPlaying = false
        m.top.isPaused = false
    else if m.video.state = "paused"
        m.top.isPaused = true
    else if m.video.state = "finished"
        if m.top.isError
            m.top.isError = false
        else
            StopVideo()
        end if 
    else if m.video.state = "error"
        print "MoviePlayer: errorCode = ";m.video.errorCode
        print "MoviePlayer: errorStr = ";m.video.errorStr
        print "MoviePlayer: errorMsg = ";m.video.errorMsg
        m.top.isError = true
        ShowDialog(getTr("Error"), getTr("Incorrect movie's URL...")+" "+m.video.errorMsg)
    end if
end sub

sub OnPositionGhange()
    'print "MoviePlayer: OnPositionGhange = ";m.video.position
    m.top.currentPosition = Int(m.video.position)
    UpdateOSD(m.top.currentPosition)
end sub
'******************************************************
sub ShowOSD()
    print "ShowOSD..."
    m.OSDPanel.visible = true
    if m.top.isSeeked
        m.OSDTimer.control = "stop"
    else
        m.OSDTimer.control = "start"
        UpdateOSD(m.top.currentPosition)
    end if
end sub

sub HideOSD()
    print "HideOSD..."
    if m.top.onTop = false
        ShowOSD()
    else
        m.OSDPanel.visible = false
        m.OSDTimer.control = "stop"
    end if
end sub

sub ShowPause()
    print "ShowPause..."
    m.OSDseek.visible = true
    m.OSDseekPause.uri = "pkg:/images/pause.png"
    m.OSDseekTime.text = ""
end sub

sub HidePause()
    print "HidePause..."
    m.OSDseek.visible = false
    m.OSDseekPause.uri = ""
    m.OSDseekTime.text = ""
end sub
'******************************************************
sub SetOSD(progress, time, title)
    print "SetOSD: "+time+" - "+title
    if m.top.movieSeriesID <> 0 and m.global.seriesCurrent <> invalid
        m.OSDchannelName.text = m.top.movieTitle + " " + getTr("Season") + " " + m.global.seriesCurrent.season.tostr() + " " + getTr("Episode") + " " + m.global.seriesCurrent.sqNum.tostr()
    else
        m.OSDchannelName.text = m.top.movieTitle
    end if
    m.OSDchannelIcon.uri = m.top.movieIconURI
    m.OSDprogress.width = m.progressDefault + m.OSDBack.width * progress 
    m.OSDprogramName.text = time '+ " - " + title
    'if m.top.isLive
    '    m.OSDprogramName.text = time + " - " + title
    '    m.OSDStatus.uri = "pkg:/images/archive_live.png"
    'else
    '    m.OSDprogramName.text = time + " - " + title + " (" + m.global.archiveDateString+")"
    '    m.OSDStatus.uri = "pkg:/images/archive_yes.png"
    'end if
end sub
'******************************************************
sub UpdateOSD(position)
    print "GET OSD: time = "+position.tostr()

    duration = 1
    if m.video.duration > 0
        duration = m.video.duration
    end if
    
    if position < 0 
        position = 0
    end if
    
    if position >= duration
        position = duration-1
    end if
    
    progress = position/duration
    time = convertSecondsToTime(position)+"/"+convertSecondsToTime(duration)
    title = "" 'GetCinemaTitle(m.global.channels[m.top.playingChannel.channelNum].description)
    SetOSD(progress, time, title)
end sub
'******************************************************
Function OnKeyEvent(key, press) as Boolean    
    result = false
    if press then
        print "MoviePlayer: OnkeyPress = ";key
        if key = "OK"  
            ShowOSD()
            result = true
        else if key = "options"

        else if key = "back"
            StopVideo()
            result = true
        else if key = "up"
            ShowOSD()
            result = true
        else if key = "down"
            ShowOSD()
            result = true
        else if key = "play"
            if m.video.state = "paused"
                ResumeVideo()
            else if m.video.state = "playing"
                PauseVideo()
            end if
            result = true
        else if key = "fastforward"
            StartSeek(60)
        else if key = "rewind"
            StartSeek(-60)
        end if
    else

        print "MoviePlayer: OnkeyRelease = ";key
        if key = "fastforward"
            StopSeekDelay()
        else if key = "rewind"
            StopSeekDelay()
        end if
    end if
    return result
End Function