Function getGenres() As Object
    print "...Get Genres"
    json = sendGetRequest(m.apipath+m.apiname+"/core/ws/Genre?id=0&typeId=TV&deviceId=1&sessionId="+ m.sessionId)
    if(json<>invalid)
        genres = CreateObject("roArray", json.total+2, true)
        genres[0]={line:true,typeId:"TV",name:"All",logo:"images/tv/genres/galaTV_03.png",allowed:true,id:-1}
        genres[1]={line:true,typeId:"TV",name:"Favorites",logo:"images/tv/genres/galaTV_02.png",allowed:true,id:0}
                    
        print "________Genres Names__________"
        print genres[0].name
        print genres[1].name
                    
        for x = 0 To json.total-1
            genres[x+2]  = json.items[x]
            print genres[x+2].name
        End for
        print "______________________________"
        return genres
    endif
    print "...Genres Error" 
    return invalid
End Function
'******************************************************
Function getChannels(id) As Object
    print "...Get Channels"
    json = {}
    url = ""
    if(id = -1)
        url = m.apipath+m.apiname+"/tv/ws/Channel?deviceId=1&id=0&active=true&sessionId="+m.sessionId
    else
        url = m.apipath+m.apiname+"/tv/ws/Channel?deviceId=1&id=0&active=true&genreId="+id.tostr()+"&sessionId="+m.sessionId
    endif
    json = sendGetRequest(url)
    if(json<>invalid)
        channels = CreateObject("roArray", json.total, true)
              
        print "________Channels Names__________"
                 
        for x = 0 To json.total-1
            channels[x]  = json.items[x]
            print channels[x].name
        End for
        print "______________________________"
        return channels
    endif
    print "...Channels Error" 
    return invalid
End Function
'******************************************************
Function getChannelOSD(id) As Object
    print "...Get Channel OSD"
    json = {}
	
    osd = CreateObject("roAssociativeArray")
    osd.start = ""
    osd.endtime = ""
    osd.title = ""
    osd.passed = 0
    osd.startTimestamp = 0
    osd.endTimestamp = 1
    osd.next = CreateObject("roAssociativeArray")
    osd.next.start = ""
    osd.next.endtime = ""
    osd.next.title = ""
    osd.next.passed = 0
    osd.next.startTimestamp = 0
    osd.next.endTimestamp = 1
	
	now = CreateObject("roDateTime")
    timestamp% = now.AsSeconds()
    if(m.timeShift and m.channels[m.curChannel].record)
    	shift = -(getTimeZoneOffsetById(m.channels[m.curChannel].timezoneId)-getTimeZoneOffsetById(m.timeZoneId))
    	if(shift>0) 
            timestamp% = timestamp% - shift
        end if
        print "PLAYshift=" + Str(shift/3600)  
    end if
	
    url = m.apipath+m.apiname+"/tv/ws/ChannelOsd?channelId="+id.tostr()+"&next=1&timestamp=" + (timestamp% + 1).tostr()+"&sessionId="+m.sessionId
    json = sendGetRequest(url)
    if(json<>invalid)
        print json.title
        osd = json'.start+" - "+json.title
		if(json.next.total > 0)
			osd.next = json.next.items[0]
		end if
        return osd
    endif
    print "...Channel OSD Error" 
    return osd
End Function
'******************************************************
Function getArchiveOSD(timestamp) As Object
    print "...Get Archive OSD"
    json = {}
    osd = CreateObject("roAssociativeArray")
    osd.start = ""
    osd.endtime = ""
    osd.title = ""
    osd.passed = 0
    osd.startTimestamp = 0
    osd.endTimestamp = 1
    osd.next = CreateObject("roAssociativeArray")
    osd.next.start = ""
    osd.next.endtime = ""
    osd.next.title = ""
    osd.next.passed = 0
    osd.next.startTimestamp = 0
    osd.next.endTimestamp = 1
    url = m.apipath+m.apiname+"/tv/ws/ChannelOsd?channelId="+ m.channels[m.curChannel].id.tostr()+"&timestamp=" + (timestamp + 1).tostr()+"&next=1&sessionId="+m.sessionId
    json = sendGetRequest(url)
    if(json<>invalid)
        print json.title
        osd = json'.start+" - "+json.title
        osd.next = json.next.items[0]
        return osd
    endif
    print "...Archive OSD Error" 
    return osd
End Function
'******************************************************
Function getChannelUrl(id) As Object
    print "...Get Channel URL"
    json = {}
    url = m.apipath+m.apiname+"/tv/ws/TransmissionUrl?poolType=TV&channelId="+id.tostr()+"&sessionId="+m.sessionId
    json = sendGetRequest(url)
    if(json<>invalid)
        print json.url
        return json.url
    endif
    print "...Channel URL Error" 
    return invalid
End Function
'******************************************************
Function getPinChannelUrl(id) As Object
    print "...Get Channel URL"
    json = {}
    url = m.apipath+m.apiname+"/tv/ws/TransmissionUrl?poolType=TV&channelId="+id.tostr()+"&pin=" + m.pin +"&sessionId="+m.sessionId
    json = sendGetRequest(url)
    if(json<>invalid)
        print json.url
        return json.url
    endif
    print "...Channel URL Error" 
    return invalid
End Function
'******************************************************
Function getChannelEPG(id) As Object
    print "...Get Channel EPG"
    json = {}
    programs = []
	url = m.apipath+m.apiname+"/tv/ws/EpgPrograms?channelId="+id.tostr()+"&day=" + m.dayNum.tostr()+"&sessionId="+m.sessionId
    'url = m.apipath+m.apiname+"/tv/ws/EpgPrograms?channelId="+id.tostr()+"&startDate=" + m.currentDayTimeStamp.tostr() + "&endDate="+(m.currentDayTimeStamp+86399).tostr()+"&sessionId="+m.sessionId
    json = sendGetRequest(url)
    if(json<>invalid)
        print "Programs TOTAL: "+json.total.tostr()
        programs = json.items
        return programs
    endif
    print "...Channel EPG Error" 
    return programs
End Function
'******************************************************
Function changeChannelFavorite(number) as Void
    id = m.channels[number].id
    fav = ""
    if (m.channels[number].favorite)
        fav = "false"
        m.channels[number].favorite = false
    else
        fav = "true"
        m.channels[number].favorite = true
    end if 
    url = m.apipath+m.apiname+"/tv/ws/Channel?sessionId="+m.sessionId
    params = "id="+id.tostr()+"&favorite="+fav
    sendPostRequest(url, params)
    updateChannelScreen()
End Function
'******************************************************
Function sendChannelTranslationFailed(_error_code, _error_message, _url) As Object
    print "...Send Channel Translation Failed: (" + _error_code + ") " + _error_message
	'_mac = m.info.GetConnectionInfo().mac
	'_user = m.user.username
	_chID = m.curPlayedChannelId
	'_url = m.playUrl
	
	if _error_code<>invalid and _error_message<>invalid and _chID<>invalid and _url<>invalid
		json = {}
		url = m.apipath+m.apiname+"/Channels/ws/editStbLog?sessionId="+m.sessionId
		params = "id="+_chID.tostr()+"&playUrl="+_url+"&errCode="+_error_code+"&errDesc="+_error_message
		json = sendPostRequest(url, params)
		if (json<>invalid)
			if (json.AccountId<>invalid)
				print json.AccountId
				return json.AccountId
			else if (json.description<>invalid)
				print json.description
			end if
		end if
	end if
    print "...Error to Send Channel Translation Failed" 
    return invalid
End Function
'******************************************************